#ifndef MUIMACROS_H
#define MUIMACROS_H

#define DISPATCHERREF &GATE_dispatch
#define DISPATCHERREF2(name) &GATE##name##_dispatch

#define DOSUPER DoSuperMethodA(cl,obj,(Msg)msg)
#define GETDATA struct Data *data = INST_DATA(cl, obj)

#define BEGINMTABLE static ULONG dispatch(void); \
	static struct EmulLibEntry GATE_dispatch = \
	{ \
		TRAP_LIB, 0, (void (*)(void)) dispatch \
	}; \
	static ULONG dispatch(void) \
	{ \
		struct IClass *cl = (struct IClass *)REG_A0; \
		Msg msg = (Msg)REG_A1; \
		Object *obj = (Object *)REG_A2; \
		switch (msg->MethodID) \
		{

#define ENDMTABLE }return(DOSUPER);}

#define DECNEW case OM_NEW:return(handleOM_NEW(cl, obj, (APTR)msg));
#define DECCONST DECNEW // obsolete
#define DECDISPOSE case OM_DISPOSE:return(handleOM_DISPOSE(cl, obj, (APTR)msg));
#define DECDISP DECDISPOSE // obsolete
#define DECSET case OM_SET:return(handleOM_SET(cl, obj, (APTR)msg));
#define DECGET case OM_GET:return(handleOM_GET(cl, obj, (APTR)msg));
#define DECADDMEMBER case OM_ADDMEMBER:return(handleOM_ADDMEMBER(cl, obj, (APTR)msg));
#define DECREMMEMBER case OM_REMMEMBER:return(handleOM_REMMEMBER(cl, obj, (APTR)msg));
#define DECMMETHOD(methodid) case MUIM_##methodid:return(handleMUIM_##methodid(cl,obj,(APTR)msg));
#define DECMETHOD(methodid) case MM_##methodid:return(handleMM_##methodid(cl,obj,(APTR)msg));
#define DECSMETHOD(methodid) case MM_##methodid:return(handleMM_##methodid(cl,obj,(APTR)msg));
#define DECTMETHOD(methodid) case MM_##methodid:return(handleMM_##methodid(cl,obj,(APTR)msg));

#define DEFMMETHOD(methodid) static ULONG handleMUIM_##methodid(struct IClass *cl,Object*obj,struct MUIP_##methodid *msg)
#define DEFMETHOD(methodid,type) static ULONG handleMM_##methodid(struct IClass *cl, Object *obj, type *msg)
#define DEFTMETHOD(methodid) static ULONG handleMM_##methodid(struct IClass *cl, Object *obj, Msg msg)
#define DEFSMETHOD(name) static ULONG handleMM_##name(struct IClass *cl,Object*obj,struct MP_##name *msg)

#define DEFNEW static ULONG handleOM_NEW(struct IClass *cl,Object*obj,struct opSet *msg)
#define DEFSET static ULONG handleOM_SET(struct IClass *cl,Object*obj,struct opSet *msg)
#define DEFGET static ULONG handleOM_GET(struct IClass *cl,Object*obj,struct opGet *msg)
#define DEFDISPOSE static ULONG handleOM_DISPOSE( struct IClass *cl,Object*obj,struct opSet *msg)
#define DEFDISP DEFDISPOSE

#define DECSUBCLASS_NC(super,name) static struct MUI_CustomClass *mcc##name; \
	ULONG create_##name(void) \
	{ \
		if (!(mcc##name = (struct MUI_CustomClass *)MUI_CreateCustomClass(NULL, super, NULL, sizeof(struct Data), DISPATCHERREF))) \
			return (FALSE); \
		mcc##name->mcc_Class->cl_ID = #name; \
		return (TRUE); \
	} \
	void delete_##name(void) \
	{ \
		if (mcc##name) \
			MUI_DeleteCustomClass(mcc##name); \
	} \
	APTR get##name(void) \
	{ \
		return (mcc##name->mcc_Class); \
	}

#endif /* MUIMACROS_H */
